QGIS Application - Bug report #17307

Problem with conversion of python strings, e.g. when labeling using setCustomProperty()

2017-10-20 10:32 AM - Markus Woehling

Status: Closed

Priority: High

Assignee:

Category: Python bindings / sipify

Affected QGIS version:2.18.13 Regression?: Yes

Operating System: Windows 10 x64 Easy fix?: No

Pull Request or Patch supplied: Resolution: fixed/implemented
Crashes QGIS or corrupls data: Copied to github as #: 25205
Description

For me it's not possible anymore to configure labeling (for QgsVectorLayer) using setCustomProperty().

| found out that setCustomProperty() is working fine in the python console.

So my problem is not setCustomProperty() itself, but something with the QVariant and/or QLatin1String type.

Labeling seems to be correctly configured when | check it in the python console:

layer = iface.activelLayer()
layer.customProperty("labeling")

pal’

layer.customProperty("labeling/enabled")

‘true’

But when | look at the types the result is this:
layer.customProperty("labeling").__class___

<class 'future.types.newstr.newstr'>
layer.customProperty("labeling/enabled")._ class___
<class 'future.types.newstr.newstr'>

This code does NOT make labeling work:

But this code does:

layer.setCustomProperty("labeling”, layer.customProperty("labeling"))
layer.setCustomProperty("labeling/enabled", layer.customProperty("labeling/enabled”))

layer.setCustomProperty("labeling", ‘pal’)
layer.setCustomProperty("labeling/enabled", 'true’)
And this code also - at least in the python console:

layer.setCustomProperty("labeling",str(layer.customProperty("labeling”)))
layer.setCustomProperty("labeling/enabled",str(layer.customProperty("labeling/enabled”)))

I am not able to workaround this issue, because in my plugin the str() function always return a "newstr".

Do you have any hints how | could workaround this issue?
Maybe this line of code is the cause of this problem (QgsVectorLayer.cs, line 4546 in master):

| | if ( customProperty( QStringLiteral( "labeling" ) ).toString()==QLatin1String( "pal" ) )

History

#1 - 2017-10-20 10:47 AM - Giovanni Manghi
- Priority changed from Normal to High

#2 - 2018-01-04 07:50 PM - Borys Jurgiel
- Category changed from Python plugins to Python bindings / sipify

#3 - 2019-01-21 12:34 AM - Jiirgen Fischer

- Status changed from Open to Feedback

Please test with QGIS 3.4 - QGIS 2.18 reached it's end of life.

#4 - 2019-01-21 10:14 AM - Markus Woehling

With QGIS 3.4 everything is working fine.

#5 - 2019-01-21 10:36 AM - Nyall Dawson
- Resolution set to fixed/implemented

- Status changed from Feedback to Closed
